/* eslint-disable react-hooks/exhaustive-deps */
/* eslint-disable react/no-unescaped-entities */
/* eslint-disable @next/next/no-img-element */
import { useRouter } from 'next/navigation';
import React, { useState } from 'react';
import { FormEvent } from 'react'
import { BASE_URL } from '@/app/services/apiService';
const API_URL = BASE_URL;
export default function Connexion() {
  const router = useRouter();
  const [role, setRole] = useState(2);
  const [error, setError] = useState<string | null>(null);
  const [info, setInfo] = useState<string | null>(null);
  const [erro, setErro] = useState<string | null>(null);


// 
async function handelSignup(event: FormEvent<HTMLFormElement>) {
  event.preventDefault();
  setError(null);
  setErro(null);
  
  const formData = new FormData(event.currentTarget);
  const name = formData.get("name");
  const email = formData.get("email");
  const password = formData.get("password");
  const roled = String(role);
  console.log(role);



  const response = await fetch(API_URL + "auth/register", {
    method: "POST",
    headers: { "Content-Type": "application/json" },
    body: JSON.stringify({ name, email, password, role: roled }),
  });
  
  //const user_token = data?.token;
  if (response.ok) {
    const data = await response.json();

  console.log(data);
  } else {
    // Handle errors
    const data = await response.json();
     setError(data.password);
    setErro(data.email);
    // setError(data.name)

    console.log(data);
  }
}
// 
function handleRole(role: number) {
  setRole(role);
}


  async function handleLogin(event: FormEvent<HTMLFormElement>) {
    event.preventDefault();
    
    setError(null);
    
    const formData = new FormData(event.currentTarget);
    const email = formData.get('email');
    const password = formData.get('password');

    const response = await fetch('/api/auth/login', {
      method: 'POST',
      headers: { 'Content-Type': 'application/json' },
      body: JSON.stringify({ email, password }),
    });

    if (response.ok) {
      const data = await response.json();
      const user = data.user;

      // Redirection selon le rôle de l'utilisateur
      redirectToDashboard(user.role);
    } else {
      const data = await response.json();
      setError(data.error);
      console.log(error);
    }
  }
  async function handlePasswordReset(event: FormEvent<HTMLFormElement>) {
    event.preventDefault();
    
    setError(null);
    setInfo(null);
    
    const formData = new FormData(event.currentTarget);
    const email = formData.get('email');

    const response = await fetch(API_URL+'password/recover', {
      method: 'POST',
      headers: { 'Content-Type': 'application/json' },
      body: JSON.stringify({ email}),
    });

    if (response.ok) {
      const data = await response.json();
      setInfo(data.status);

      // Redirection selon le rôle de l'utilisateur
      // redirectToDashboard(user.role);
    } else {
      const data = await response.json();
      setError(data.Erreur);
      console.log(error);
    }
  }
  const redirectToDashboard = (role:number) => {
    switch (role) {
      case 1:
        router.push('/dashboardAdmin');
        break;
      case 2:
        router.push('/dashboardUser');
        break;
      case 3:
        router.push('/dashboardEntreprise');
        break;
      case 4:
        router.push('/dashboardEducation');
        break;
      default:
        router.push('/');
    }
  };
  return (
    <>
    <div className="modal similar__modal fade " id="loginModal">
    <div className="modal-dialog modal-dialog-centered">
      <div className="modal-content">
        <div className="max-content similar__form form__padding">
          <div className="d-flex mb-3 align-items-center justify-content-between">
            <h6 className="mb-0">Se connecter à Tépé</h6>
            <button type="button" data-bs-dismiss="modal" aria-label="Close">
              <i className="fa-regular fa-xmark text-primary" />
            </button>
          </div>
          <div className="d-block has__line text-center">
            <p></p>
          </div>
          {/* <div className="tab__switch flex-wrap flex-sm-nowrap nav-tab mt-30 mb-30">
            <button className="rts__btn nav-link  active">
              <i className="fa-light fa-user" />
              Candidat
            </button>
            <button className="rts__btn nav-link">
              <i className="rt-briefcase" /> Employeur
            </button>
          </div> */}
          <div className="tab-content" id=""></div>
          <form
            onSubmit={handleLogin}
            method="post"
            className="d-flex flex-column gap-3"
          >
            <div className="form-group">
              <label htmlFor="email" className="fw-medium text-dark mb-3">
                Votre Email
              </label>
              <div className="position-relative">
                <input
                className="form-control text-black"
                  type="email"
                  name="email"
                  id="email"
                  defaultValue=""
                  placeholder="Enter your email"
                  required
                />
                <i className="fa-light fa-user icon" />
              </div>
            </div>
            <div className="form-group">
              <label htmlFor="password" className=" fw-medium text-dark mb-3">
                Mot de Passe
              </label>
              <div className="position-relative">
                <input
                                className="form-control text-black"

                  type="password"
                  name="password"
                  defaultValue={""}
                  id="password"
                  placeholder="Enter your password"
                  required
                />
                <i className="fa-light fa-lock icon" />
              </div>
            </div>
            <div className="d-flex flex-wrap justify-content-between align-items-center fw-medium">
              <div className="form-check">
                <input
                  className="form-check-input"
                  type="checkbox"
                  defaultValue=""
                  id="flexCheckDefault"
                />
                <label className="form-check-label" htmlFor="flexCheckDefault">
                  Souvenez-vous de moi
                </label>
              </div>
              <a
                href="#"
                className="forgot__password text-para"
                data-bs-toggle="modal"
                data-bs-target="#forgotModal"
              >
                Mot de Passe Oublié?
              </a>
            </div>
            {error && <p className="text-danger mb-4 text-2xl">{error}</p>}
            <div className="form-group my-3">

              <button type="submit" className="rts__btn w-100 fill__btn" >Login</button>
            </div>
          </form>
          <div className="d-block has__line text-center">
            <p>Ou</p>
          </div>
          <div className="d-flex gap-4 flex-wrap justify-content-center mt-20 mb-20">
            <div className="is__social google">
              <button>
                <img src="assets/img/icon/google-small.svg" alt="" />
                Continuer avec Google
              </button>
            </div>
            <div className="is__social facebook">
              <button>
                <img src="assets/img/icon/facebook-small.svg" alt="" />
                Continuer avec Facebook
              </button>
            </div>
          </div>
          <span className="d-block text-center fw-medium">
            Vous n'avez pas de compte?{" "}
            <a
              href="#"
              data-bs-target="#signupModal"
              data-bs-toggle="modal"
              className="text-primary"
            >
              Inscrivez-vous!
            </a>{" "}
          </span>
        </div>
      </div>
    </div>
  </div>
  {/* signup form */}
  {/* <div className="modal similar__modal fade " id="signupModal">
    <div className="modal-dialog modal-dialog-centered">
      <div className="modal-content">
        <div className="max-content similar__form form__padding">
          <div className="d-flex mb-3 align-items-center justify-content-between">
            <h6 className="mb-0">Create A Free Account</h6>
            <button type="button" data-bs-dismiss="modal" aria-label="Close">
              <i className="fa-regular fa-xmark text-primary" />
            </button>
          </div>
          <div className="d-block has__line text-center">
            <p>Choose your Account Type</p>
          </div>
          <div className="tab__switch flex-wrap flex-sm-nowrap nav-tab mt-30 mb-30">
            <button className="rts__btn nav-link  active">
              <i className="fa-light fa-user" />
              Candidate
            </button>
            <button className="rts__btn nav-link">
              <i className="rt-briefcase" /> Employer
            </button>
          </div>
          <form action="#" className="d-flex flex-column gap-3">
            <div className="form-group">
              <label htmlFor="sname" className="fw-medium text-dark mb-3">
                Your Name
              </label>
              <div className="position-relative">
                <input
                  type="text"
                  name="sname"
                  id="sname"
                  placeholder="Candidate"
                  required
                />
                <i className="fa-light fa-user icon" />
              </div>
            </div>
            <div className="form-group">
              <label htmlFor="signemail" className="fw-medium text-dark mb-3">
                Your Email
              </label>
              <div className="position-relative">
                <input
                  type="email"
                  name="signemail"
                  id="signemail"
                  placeholder="Enter your email"
                  required
                />
                <i className="fa-sharp fa-light fa-envelope icon" />
              </div>
            </div>
            <div className="form-group">
              <label htmlFor="spassword" className="fw-medium text-dark mb-3">
                Password
              </label>
              <div className="position-relative">
                <input
                  type="password"
                  name="spassword"
                  id="spassword"
                  placeholder="Enter your password"
                  required
                />
                <i className="fa-light fa-lock icon" />
              </div>
            </div>
            <div className="form-group my-3">
              <button className="rts__btn w-100 fill__btn">Login</button>
            </div>
          </form>
          <div className="d-block has__line text-center">
            <p>Or</p>
          </div>
          <div className="d-flex flex-wrap justify-content-center gap-4 mt-20 mb-20">
            <div className="is__social google">
              <button>
                <img src="assets/img/icon/google-small.svg" alt="" />
                Continue with Google
              </button>
            </div>
            <div className="is__social facebook">
              <button>
                <img src="assets/img/icon/facebook-small.svg" alt="" />
                Continue with Facebook
              </button>
            </div>
          </div>
          <span className="d-block text-center fw-medium">
            Have an account?{" "}
            <a
              href="#"
              data-bs-target="#loginModal"
              data-bs-toggle="modal"
              className="text-primary"
            >
              Login
            </a>{" "}
          </span>
        </div>
      </div>
    </div>
  </div> */}
        <div className="modal similar__modal fade " id="signupModal">
        <div className="modal-dialog modal-dialog-centered">
          <div className="modal-content">
            <div className="max-content similar__form form__padding">
              <div className="d-flex mb-3 align-items-center justify-content-between">
                <h6 className="mb-0">Create A Free Account</h6>
                <button
                  type="button"
                  data-bs-dismiss="modal"
                  aria-label="Close"
                >
                  <i className="fa-regular fa-xmark text-primary" />
                </button>
              </div>
              <div className="d-block has__line text-center">
                <p>Choose your Account Type</p>
              </div>
              <div className="tab__switch flex-wrap flex-sm-nowrap nav-tab mt-30 mb-30">
                <button
                  onClick={() => handleRole(2)}
                  className="rts__btn nav-link  active"
                >
                  <i className="fa-light fa-user" />
                  Candidat
                </button>
                <button
                  onClick={() => handleRole(3)}
                  className="rts__btn nav-link"
                >
                  <i className="rt-briefcase" /> Employeur
                </button>
              </div>
              {/*   register form action */}
              <form
                onSubmit={handelSignup}
                className="d-flex flex-column gap-3"
              >
                <div className="form-group">

                  <label htmlFor="name" className="fw-medium text-dark mb-3">
                    Your Name
                  </label>
                  <div className="position-relative">
                    <input
                      type="text"
                      name="name"
                      id="name"
                      placeholder="Candidate"
                      required
                    />
                    {/* <ZodErrors error={formState?.zodErrors?.username}/> */}
                    <i className="fa-light fa-user icon" />
                  </div>
                </div>
                <div className="form-group">
                  <label htmlFor="nemail" className="fw-medium text-dark mb-3">
                    Your Email
                  </label>
                  <div className="position-relative">
                    <input
                      type="email"
                      name="email"
                      id="email"
                      placeholder="Enter your email"
                      required
                    />
                    {erro && <p className="text-danger mb-4 text-2xl">{erro}</p>}

                    {/* <ZodErrors error={formState?.zodErrors?.email}/> */}

                    <i className="fa-sharp fa-light fa-envelope icon" />
                  </div>
                </div>
                <div className="form-group">
                  <label
                    htmlFor="password"
                    className="fw-medium text-dark mb-3"
                  >
                    Password
                  </label>
                  <div className="position-relative">
                    <input
                      type="password"
                      name="password"
                      id="password"
                      placeholder="Enter your password"
                      required
                    />
                    {error && <p className="text-danger mb-4 text-2xl">{error}</p>}

                    {/* <ZodErrors error={formState?.zodErrors?.password}/> */}

                    <i className="fa-light fa-lock icon" />
                  </div>
                </div>
                <div className="form-group my-3">
                  <button type="submit" className="rts__btn w-100 fill__btn">
                    S'inscrire
                  </button>
                </div>
              </form>
              <div className="d-block has__line text-center">
                <p>Or</p>
              </div>
              <div className="d-flex flex-wrap justify-content-center gap-4 mt-20 mb-20">
                <div className="is__social google">
                  <button>
                    <img src="assets/img/icon/google-small.svg" alt="" />
                    Continue with Google
                  </button>
                </div>
                <div className="is__social facebook">
                  <button>
                    <img src="assets/img/icon/facebook-small.svg" alt="" />
                    Continue with Facebook
                  </button>
                </div>
              </div>
              <span className="d-block text-center fw-medium">
                Have an account?{" "}
                <a
                  href="#"
                  data-bs-target="#loginModal"
                  data-bs-toggle="modal"
                  className="text-primary"
                >
                  Login
                </a>{" "}
              </span>
            </div>
          </div>
        </div>
      </div>
  {/* forgot password form */}
  <div className="modal similar__modal fade " id="forgotModal">
    <div className="modal-dialog modal-dialog-centered">
      <div className="modal-content">
        <div className="max-content similar__form form__padding">
          <div className="d-flex mb-3 align-items-center justify-content-between">
            <h6 className="mb-0">Forgot Password</h6>
            <button type="button" data-bs-dismiss="modal" aria-label="Close">
              <i className="fa-regular fa-xmark text-primary" />
            </button>
          </div>
          <form onSubmit={handlePasswordReset} method='post' className="d-flex flex-column gap-3">
            <div className="form-group">
              <label htmlFor="fmail" className="fw-medium text-dark mb-3">
                Your Email
              </label>
              <div className="position-relative">
                <input
                  type="email"
                  name="email"
                  id="fmail"
                  placeholder="Entrez votre email"
                  required
                />
                <i className="fa-sharp fa-light fa-envelope icon" />
              </div>
            </div>
            <div className="form-group my-3">
            {error && <p className="text-danger mb-4 text-2xl">{error}</p>}
            {info && <p className="text-danger mb-4 text-2xl">{info}</p>}
              <button className="rts__btn w-100 fill__btn">
                Réinitialiser Mot de Passe
              </button>
            </div>
          </form>
          <span className="d-block text-center fw-medium">
            Remember Your Password?{" "}
            <a
              href="#"
              data-bs-target="#loginModal"
              data-bs-toggle="modal"
              className="text-primary"
            >
              Login
            </a>{" "}
          </span>
        </div>
      </div>
    </div>
  </div>
  </>
  );
}
